#include <ruby.h>

#define NUM2FLT(x) ((float)NUM2DBL(x))
#define FLT2NUM(x) (rb_float_new((double)x))
#define MAX(x,y) (((x)>(y))?(x):(y))
#define MIN(x,y) (((x)<(y))?(x):(y))

#ifndef HAVE_NARRAY_H
typedef struct{ float r,i; } scomplex;
typedef struct{ double r,i; } complex;
#endif

extern int *ssl2_getcaryi(VALUE, int*);
extern long *ssl2_getcaryl(VALUE, int*);
extern float *ssl2_getcary(VALUE, int*);
extern scomplex *ssl2_getcaryc(VALUE, int*);
extern float *ssl2_getcary_withshape(VALUE, int*, int*);
extern VALUE ssl2_getaryi(int*, int, int*);
extern VALUE ssl2_getaryl(long*, int, int*);
extern VALUE ssl2_getary(float*, int, int*);
extern VALUE ssl2_getaryc(scomplex*, int, int*);

extern float func(float*);
extern void sub(float*, float*);

